using UnityEngine;using System;using System.Collections.Generic;using MVR.FileManagementSecure;using Random = UnityEngine.Random;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using MeshVR;using System.Linq;namespace PluginIdea.AME{public class AtmosphereEnhancement : MVRScript{private List<string> lightTypes = new List<string>{"DirectionLight", "PointLight", "SpotLight"};ResourceMgr resourceMgr;private Camera targetCamera, maskCam, shapeMaskCam;private GodRayPostEffect godrayPF;private JSONStorableColor threholdColor;private JSONStorableFloat sampleScale;private JSONStorableFloat downSample;private JSONStorableFloat blurIteration;private JSONStorableFloat briteness;private JSONStorableFloat dirtScale;private JSONStorableFloat flareRadiusOut, flareRadiusIn, flareRadiusOutFade, flareRadiusInFade;private JSONStorableFloat sphereMaskRadius;private JSONStorableStringChooser lightTypeChooser;private JSONStorableStringChooser lightChooser;private JSONStorableBool isUseMask;private JSONStorableColor flareColor;private JSONStorableBool isSubFromSkyDom;private JSONStorableColor fogColor;private JSONStorableFloat noiseHeight;private JSONStorableFloat fogDensityHeight;private JSONStorableFloat fogStartHeight;private JSONStorableFloat fogEndHeight;private JSONStorableFloat noiseAmount;private JSONStorableFloat fogXSpeed;private JSONStorableFloat fogYSpeed;private JSONStorableFloat domePow;private JSONStorableFloat fogDensityDis;private JSONStorableFloat fogStartDis;private JSONStorableFloat fogEndDis;private JSONStorableFloat inscatteringExponent;private JSONStorableFloat inscatterStartDistance;private JSONStorableColor inscatterColor;private Transform maskSphereTrans, maskSpotTrans;private MeshFilter meshFilter;private bool isRscInited;private static int DEFAULT_CULLING_MASK = -1;int uiMask = 1 << LayerMask.NameToLayer("UI")             | 1 << LayerMask.NameToLayer("LoadUI")             | 1 << LayerMask.NameToLayer("ScreenUI")             | 1 << LayerMask.NameToLayer("GUI");private Transform emptyTrans;private Light targetLight;private Atom currentDirLightAtom;private Transform dirLightTrans;private bool ffs;public override void Init(){Utils.CenterCamera.depthTextureMode = DepthTextureMode.Depth;SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;Location.InitTData();Utils.InitUI(CreateUIElement);resourceMgr = new ResourceMgr(this);resourceMgr.onInitSuccess = OnRscInitSuccess;targetCamera = Utils.CenterCamera;targetCamera.cullingMask &= ~(1 << LayerMask.NameToLayer("Ignore Raycast"));dirLightTrans = new GameObject("tLightTrans").transform;emptyTrans = new GameObject("EmptyTrans").transform;ffs = Utils.IsCerPass();if (!ffs){Utils.CC2(this);}var btn = Utils.CreateButton(this, Location.GetStr(Location.OpenMainPage), () =>{if (Location.IsChinease) Application.OpenURL(@"https:\/\/afdian.net/p/6f6685ceae9211ed8c8952540025c377");else Application.OpenURL(@"https:\/\/www.patreon.com/PluginIdea/about");}, false, true);btn.buttonImage.color = Color.yellow;Utils.CreateSpacer(this, 30, false);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.CommonParaSubtitle), 40, false);Utils.CreateButton(this, Location.GetStr(Location.RefreshLightAtoms), RefreshLightsAtoms, false, true);lightChooser = Utils.CreateStringChooser(this, Location.GetStr(Location.SelectLight), new List<string>(), false, true);lightChooser.setCallbackFunction = (val) =>{if (!isRscInited || string.IsNullOrEmpty(val)) return;Atom lightAtom = SuperController.singleton.GetAtomByUid(val);if (lightAtom){currentDirLightAtom = lightAtom;targetLight = currentDirLightAtom.reParentObject.GetComponentInChildren<Light>();lightTypeChooser.setCallbackFunction(lightTypeChooser.val);}};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.FogHeightParaSubtitle), 40, true);noiseHeight = Utils.CreateSliderFloat(this, Location.GetStr(Location.NoiseHeight), 2f, 0f, 50f, true,ffs);noiseHeight.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_NoiseHeight", val);};fogColor = Utils.CreateColor(this, Location.GetStr(Location.FogColor), Color.white, false);fogColor.setCallbackFunction = (h, s, v) =>{if (!isRscInited) return;godrayPF.m_postMat.SetColor("_FogColor", Color.HSVToRGB(h, s, v));};fogDensityHeight = Utils.CreateSliderFloat(this, Location.GetStr(Location.FogDensityHeight), 1f, 0f, 2f, true, ffs);fogDensityHeight.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_FogDensityHeight", val);};fogStartHeight = Utils.CreateSliderFloat(this, Location.GetStr(Location.FogStartHeight), -50f, -100f, 20f, true, ffs);fogStartHeight.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_FogStartHeight", val);};fogEndHeight = Utils.CreateSliderFloat(this, Location.GetStr(Location.FogEndHeight), 0f, 0f, 100f, true, ffs);fogEndHeight.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_FogEndHeight", val);};noiseAmount = Utils.CreateSliderFloat(this, Location.GetStr(Location.NoiseTileAmount), 10f, 0f, 2f, true, ffs);noiseAmount.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_NoiseAmount", val);};fogXSpeed = Utils.CreateSliderFloat(this, Location.GetStr(Location.FogSpeedX), 0.2f, 0f, 2f, true, ffs);fogXSpeed.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_FogXSpeed", val);};fogYSpeed = Utils.CreateSliderFloat(this, Location.GetStr(Location.FogSpeedY), 0.2f, 0f, 2f, true, ffs);fogYSpeed.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_FogYSpeed", val);};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.FogDistanceParaSubtitle), 40, true);fogDensityDis = Utils.CreateSliderFloat(this, Location.GetStr(Location.FogDensityDis), 1f, 0f, 2f, true, ffs);fogDensityDis.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_FogDensityDis", val);};fogStartDis = Utils.CreateSliderFloat(this, Location.GetStr(Location.FogStartDis), 0f, -10f, 50, true, ffs);fogStartDis.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_FogStartDis", val);};fogEndDis = Utils.CreateSliderFloat(this, Location.GetStr(Location.FogEndDis), 60, 0f, 1000f, true, ffs);fogEndDis.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_FogEndDis", val);};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.Dome), 40, true);domePow = Utils.CreateSliderFloat(this, Location.GetStr(Location.DomePowAmount), 2f, 0f, 10f, true, ffs);domePow.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_DomePow", val);};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.InscatterParaSubtitle), 40, true);inscatteringExponent = Utils.CreateSliderFloat(this, Location.GetStr(Location.InscatteringExponent), 3, 0f, 10, true, ffs);inscatteringExponent.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_InscatteringExponent", val);};inscatterStartDistance = Utils.CreateSliderFloat(this, Location.GetStr(Location.InscatterStartDistance), 100, 0f, 100, true, ffs);inscatterStartDistance.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_InscatterStartDistance", val);};inscatterColor = Utils.CreateColor(this, Location.GetStr(Location.InscatterColor), Color.white, true);inscatterColor.setCallbackFunction = (h, s, v) =>{if (!isRscInited) return;godrayPF.m_postMat.SetColor("_InscatterColor", Color.HSVToRGB(h, s, v));};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.GodRayParaSubtitle), 40, false);flareColor = Utils.CreateColor(this, Location.GetStr(Location.FlareColor), Color.white, false);flareColor.setCallbackFunction = (h, s, v) =>{if (!isRscInited) return;godrayPF.m_postMat.SetColor("_FlareColor", Color.HSVToRGB(h, s, v));};dirtScale = Utils.CreateSliderFloat(this, Location.GetStr(Location.DirtScale), 1f, 0f, 2f, false, ffs);dirtScale.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_DirtScale", val);};flareRadiusOut = Utils.CreateSliderFloat(this, Location.GetStr(Location.FlareRadiusOut), 0.5f, 0f, 2f, false, ffs);flareRadiusOut.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.lightRadiusOut = val;};flareRadiusOutFade = Utils.CreateSliderFloat(this, Location.GetStr(Location.FlareRadiusOutFade), 0f, 0f, 0.3f, false, ffs);flareRadiusOutFade.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.lightRadiusOutFade = val;};flareRadiusIn = Utils.CreateSliderFloat(this, Location.GetStr(Location.FlareRadiusIn), 0f, 0f, 0.3f, false, ffs);flareRadiusIn.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.lightRadiusIn = val;};flareRadiusInFade = Utils.CreateSliderFloat(this, Location.GetStr(Location.FlareRadiusInFade), 0f, 0f, 0.2f, false, ffs);flareRadiusInFade.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.lightRadiusInFade = val;};briteness = Utils.CreateSliderFloat(this, Location.GetStr(Location.Brightness), 2f, 0f, 4f, false, ffs);briteness.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.lightPower = val;};threholdColor = Utils.CreateColor(this, Location.GetStr(Location.ThreholdColor), Color.gray, false);threholdColor.setCallbackFunction = (h, s, v) =>{if (!isRscInited) return;godrayPF.colorThreshold = Color.HSVToRGB(h, s, v);};sampleScale = Utils.CreateSliderFloat(this, Location.GetStr(Location.SampleScale), 4f, 0f, 20, false, ffs);sampleScale.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.samplerScale = val;};downSample = Utils.CreateSliderInt(this, Location.GetStr(Location.DownSample), 2, 1, 5, false,ffs);downSample.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.downSample = (int)val;};blurIteration = Utils.CreateSliderInt(this, Location.GetStr(Location.Iteration), 4, 1, 10, false, ffs);blurIteration.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.blurIteration = (int)val;};lightTypeChooser = Utils.CreateStringChooser(this, Location.GetStr(Location.LightType), lightTypes, false, ffs);lightTypeChooser.setCallbackFunction = (val) =>{if (!isRscInited || string.IsNullOrEmpty(val)) return;Debug.Log("2222222");if (isSubFromSkyDom.val && emptyTrans != null){Debug.Log("33333333");godrayPF.lightTransform = emptyTrans;godrayPF.isRenderSkyLight = true;}else if (targetLight != null){godrayPF.lightTransform = targetLight.transform;if (maskSphereTrans) maskSphereTrans.gameObject.SetActive(false);if (maskSpotTrans) maskSpotTrans.gameObject.SetActive(false);godrayPF.isRenderSkyLight = false;if (val == "DirectionLight"){targetLight.type = LightType.Directional;godrayPF.lightTransform = targetLight.transform;godrayPF.isRenderSkyLight = true;}else if (val == "PointLight"){targetLight.type = LightType.Point;if (maskSphereTrans == null){maskSphereTrans = GameObject.CreatePrimitive(PrimitiveType.Sphere).transform;maskSphereTrans.gameObject.layer = LayerMask.NameToLayer("Ignore Raycast");maskSphereTrans.SetParent(targetLight.transform);maskSphereTrans.localPosition = Vector3.zero;maskSphereTrans.localScale = targetLight.range * 0.5f * Vector3.one;maskSphereTrans.GetComponent<Collider>().enabled = false;maskSphereTrans.GetComponent<MeshRenderer>().material = resourceMgr.dic_name2Materials["ShapeMask"];godrayPF.lightTransform = maskSphereTrans;}maskSphereTrans.gameObject.SetActive(true);}else{targetLight.type = LightType.Spot;if (maskSpotTrans == null){maskSpotTrans = new GameObject("SpotShape").transform;maskSpotTrans.gameObject.layer = LayerMask.NameToLayer("Ignore Raycast");maskSpotTrans.SetParent(targetLight.transform);maskSpotTrans.localPosition = Vector3.zero;maskSpotTrans.localEulerAngles = Vector3.zero;meshFilter = maskSpotTrans.gameObject.AddComponent<MeshFilter>();var render = maskSpotTrans.gameObject.AddComponent<MeshRenderer>();render.material = resourceMgr.dic_name2Materials["ShapeMask"];meshFilter.mesh = MeshGenerator.GenerateConeLengthZ_RadiusAndAngle(targetLight.range, 0, targetLight.spotAngle, 5, 5, false, false);godrayPF.lightTransform = maskSpotTrans;}maskSpotTrans.gameObject.SetActive(true);}}};isUseMask = Utils.CreateToggle(this, Location.GetStr(Location.IsUseMask), true, false,ffs);isUseMask.setCallbackFunction = (val) =>{if (!isRscInited) return;godrayPF.m_postMat.SetFloat("_IsUseMask", val ? 1 : 0);};isSubFromSkyDom = Utils.CreateToggle(this, Location.GetStr(Location.IsSunFromSkydome), true, false, ffs);}private void OnSceneLoaded(){RefreshLightsAtoms();lightChooser.setCallbackFunction(lightChooser.val);}private float lastSpotRange, lastSpotAngle;private void Update(){if (isRscInited){if (isSubFromSkyDom.val){Vector3 subDir = Shader.GetGlobalVector("SunPos");emptyTrans.position = targetCamera.transform.position - subDir * 100;}else if (targetLight){if (targetLight.type == LightType.Directional){if (Input.GetKey(KeyCode.LeftAlt) && Input.GetMouseButtonDown(0)){var mousePos = Input.mousePosition;Ray ray = targetCamera.ScreenPointToRay(mousePos);Vector3 targetPos = targetCamera.transform.position + ray.direction * 1000;currentDirLightAtom.mainController.transform.position = targetPos;currentDirLightAtom.mainController.transform.LookAt(targetCamera.transform.position);}}else if (targetLight.type == LightType.Point && maskSphereTrans){maskSphereTrans.localScale = targetLight.range * 0.5f * Vector3.one;}else if (targetLight.type == LightType.Spot && maskSpotTrans){if (lastSpotAngle != targetLight.spotAngle || lastSpotRange != targetLight.spotAngle){lastSpotAngle = targetLight.spotAngle;lastSpotRange = targetLight.range;if (meshFilter) meshFilter.mesh = MeshGenerator.GenerateConeLengthZ_RadiusAndAngle(targetLight.range, 0, targetLight.spotAngle, 5, 5, false, false);}}}}}private Camera uiCamera;private void OnRscInitSuccess(){if (!Utils.IsInVR()){int worldMask = targetCamera.cullingMask &= ~uiMask;targetCamera.cullingMask = worldMask;if (uiCamera == null){var temp = new GameObject("NewUICamera");temp.transform.SetParent(targetCamera.transform);uiCamera = Utils.GetSafeComponent<Camera>(temp);uiCamera.CopyFrom(targetCamera);uiCamera.transform.localPosition = Vector3.zero;uiCamera.transform.localRotation = Quaternion.identity;uiCamera.cullingMask = uiMask;uiCamera.clearFlags = CameraClearFlags.Depth;uiCamera.depth = targetCamera.depth + 1;uiCamera.enabled = true;}}var maskCamObj = new GameObject("maskCamera");maskCamObj.transform.SetParent(Utils.CenterCameraTrans);maskCamObj.transform.localPosition = Vector3.zero;maskCamObj.transform.localRotation = Quaternion.identity;maskCam = Utils.GetSafeComponent<Camera>(maskCamObj);maskCam.CopyFrom(targetCamera);maskCam.clearFlags = CameraClearFlags.SolidColor;maskCam.backgroundColor = Color.white;var shapeMaskCamObj = new GameObject("shapeMaskCamera");shapeMaskCamObj.transform.SetParent(Utils.CenterCameraTrans);shapeMaskCamObj.transform.localPosition = Vector3.zero;shapeMaskCamObj.transform.localRotation = Quaternion.identity;shapeMaskCam = Utils.GetSafeComponent<Camera>(shapeMaskCamObj);shapeMaskCam.CopyFrom(targetCamera);shapeMaskCam.clearFlags = CameraClearFlags.SolidColor;shapeMaskCam.backgroundColor = Color.black;shapeMaskCam.cullingMask = 1 << LayerMask.NameToLayer("Ignore Raycast");godrayPF = Utils.GetSafeComponent<GodRayPostEffect>(targetCamera.gameObject);godrayPF.m_postMat = resourceMgr.dic_name2Materials["Custom_GodRay"];godrayPF.replaceMentShader = resourceMgr.dic_BundleShaders["GodRay/Mask"];godrayPF.shapeReplaceMentShader = resourceMgr.dic_BundleShaders["GodRay/ShapeMask"];godrayPF.maskCamera = maskCam;godrayPF.shapeCamera = shapeMaskCam;godrayPF.m_postMat.SetFloat("_IsVR", Utils.IsInVR() ? 1 : 0);maskCam.targetTexture = GodRayPostEffect.maskTexture;shapeMaskCam.targetTexture = GodRayPostEffect.shapeTexture;isRscInited = true;OnReapply();}private void OnReapply(){noiseHeight.setCallbackFunction(noiseHeight.val);fogDensityHeight.setCallbackFunction(fogDensityHeight.val);fogStartHeight.setCallbackFunction(fogStartHeight.val);fogEndHeight.setCallbackFunction(fogEndHeight.val);noiseAmount.setCallbackFunction(noiseAmount.val);fogXSpeed.setCallbackFunction(fogXSpeed.val);fogYSpeed.setCallbackFunction(fogYSpeed.val);domePow.setCallbackFunction(domePow.val);fogDensityDis.setCallbackFunction(fogDensityDis.val);fogStartDis.setCallbackFunction(fogStartDis.val);fogEndDis.setCallbackFunction(fogEndDis.val);inscatteringExponent.setCallbackFunction(inscatteringExponent.val);inscatterStartDistance.setCallbackFunction(inscatterStartDistance.val);inscatterColor.setCallbackFunction(inscatterColor.val.H, inscatterColor.val.S, inscatterColor.val.V);sampleScale.setCallbackFunction(sampleScale.val);briteness.setCallbackFunction(briteness.val);downSample.setCallbackFunction(downSample.val);blurIteration.setCallbackFunction(blurIteration.val);isUseMask.setCallbackFunction(isUseMask.val);flareRadiusInFade.setCallbackFunction(flareRadiusInFade.val);flareRadiusIn.setCallbackFunction(flareRadiusIn.val);flareRadiusOutFade.setCallbackFunction(flareRadiusOutFade.val);flareRadiusOut.setCallbackFunction(flareRadiusOut.val);dirtScale.setCallbackFunction(dirtScale.val);threholdColor.setCallbackFunction(threholdColor.val.H,threholdColor.val.S,threholdColor.val.V);flareColor.setCallbackFunction(flareColor.val.H, flareColor.val.S, flareColor.val.V);RefreshLightsAtoms();lightChooser.setCallbackFunction(lightChooser.val);if (isSubFromSkyDom.val) lightTypeChooser.setCallbackFunction(lightTypeChooser.val);}private void RefreshLightsAtoms(){var atoms = SuperController.singleton.GetAtoms().Where(x => x.type == "InvisibleLight").ToList();if (atoms.Count > 0){lightChooser.choices = atoms.Select(x => x.uid).ToList();}}private void OnDestroy(){Utils.DestroyUI();SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;if (godrayPF) Destroy(godrayPF);if(dirLightTrans) Destroy(dirLightTrans.gameObject);if (maskCam) Destroy(maskCam.gameObject);if (shapeMaskCam) Destroy(shapeMaskCam.gameObject);if (maskSphereTrans) Destroy(maskSphereTrans.gameObject);if (maskSpotTrans) Destroy(maskSpotTrans.gameObject);if (emptyTrans) Destroy(emptyTrans.gameObject);if (!Utils.IsInVR()){targetCamera.cullingMask = DEFAULT_CULLING_MASK;if (uiCamera) Destroy(uiCamera.gameObject);}}}}