using UnityEngine;namespace PluginIdea.AME{public class GodRayPostEffect : MonoBehaviour{public static RenderTexture maskTexture, shapeTexture;public Material m_postMat;public Color colorThreshold = Color.gray;public Color lightColor = Color.white;public float samplerScale = 4.0f;public int blurIteration = 2;public int downSample = 2;public Transform lightTransform;public float lightPower = 1;public float lightRadiusOut = 0.5f, lightRadiusIn = 0.1f;public float lightRadiusOutFade = .15f, lightRadiusInFade = 0.05f;public Shader replaceMentShader = null;public Shader shapeReplaceMentShader = null;private Camera targetCamera = null;public Camera maskCamera = null;public Camera shapeCamera = null;void Awake(){maskTexture = RenderTexture.GetTemporary(Screen.width, Screen.height, 0, RenderTextureFormat.R8);shapeTexture = RenderTexture.GetTemporary(Screen.width, Screen.height, 0, RenderTextureFormat.R8);targetCamera = GetComponent<Camera>();}void OnEnable(){if (maskCamera != null){maskCamera.targetTexture = maskTexture;maskCamera.enabled = true;}if (shapeCamera != null){shapeCamera.targetTexture = shapeTexture;shapeCamera.enabled = true;}}void OnDisable(){if (maskCamera != null){maskCamera.targetTexture = null;maskCamera.enabled = false;}if (shapeCamera != null){shapeCamera.targetTexture = null;shapeCamera.enabled = false;}}void OnDestroy(){if (maskCamera != null){Destroy(maskCamera.gameObject);maskCamera = null;}if (shapeCamera != null){Destroy(shapeCamera.gameObject);shapeCamera = null;}if (maskTexture != null){RenderTexture.ReleaseTemporary(maskTexture);maskTexture = null;}if (shapeTexture != null){RenderTexture.ReleaseTemporary(shapeTexture);shapeTexture = null;}}public bool isRenderSkyLight;void OnPreRender(){}void OnRenderImage(RenderTexture source, RenderTexture destination){if (maskCamera != null && isRenderSkyLight){maskCamera.RenderWithShader(replaceMentShader, "RenderType");}if (shapeCamera != null){shapeCamera.RenderWithShader(shapeReplaceMentShader, "RenderType");}if (m_postMat && targetCamera){int rtWidth = source.width >> downSample;int rtHeight = source.height >> downSample;if (Utils.IsInVR()){RenderTexture temp1 = RenderTexture.GetTemporary(rtWidth, rtHeight, 0, source.format);RenderTexture tempEx = RenderTexture.GetTemporary(rtWidth, rtHeight, 0, source.format);RenderTexture mergeBlurRT = RenderTexture.GetTemporary(rtWidth, rtHeight, 0, source.format);Vector3 viewPortLightPos = lightTransform == null ? new Vector3(.5f, .5f, 0) : targetCamera.WorldToViewportPoint(lightTransform.position);m_postMat.SetVector("_ColorThreshold", colorThreshold);m_postMat.SetTexture("_MaskTexture", maskTexture);m_postMat.SetTexture("_ShapeMask", shapeTexture);m_postMat.SetVector("_SunPos", lightTransform.position);m_postMat.SetVector("_LightPos", new Vector4(viewPortLightPos.x * 0.5f, viewPortLightPos.y, viewPortLightPos.z, 0));Graphics.Blit(source, temp1, m_postMat, 0);m_postMat.SetVector("_LightPos", new Vector4((viewPortLightPos.x + 1) * 0.5f, viewPortLightPos.y, viewPortLightPos.z, 0));Graphics.Blit(source, tempEx, m_postMat, 0);m_postMat.SetVector("_LightPos", new Vector4(viewPortLightPos.x * 0.5f, viewPortLightPos.y, viewPortLightPos.z, 0));float samplerOffset = samplerScale / source.width;for (int i = 0;i < blurIteration;i++){RenderTexture temp2 = RenderTexture.GetTemporary(rtWidth, rtHeight, 0, source.format);float offset = samplerOffset * (i * 2 + 1);m_postMat.SetVector("_offsets", new Vector4(offset * 0.5f, offset, 0, 0));Graphics.Blit(temp1, temp2, m_postMat, 1);offset = samplerOffset * (i * 2 + 2);m_postMat.SetVector("_offsets", new Vector4(offset * 0.5f, offset, 0, 0));Graphics.Blit(temp2, temp1, m_postMat, 1);RenderTexture.ReleaseTemporary(temp2);}m_postMat.SetVector("_LightPos", new Vector4((viewPortLightPos.x + 1) * 0.5f, viewPortLightPos.y, viewPortLightPos.z, 0));for (int i = 0;i < blurIteration;i++){RenderTexture temp2 = RenderTexture.GetTemporary(rtWidth, rtHeight, 0, source.format);float offset = samplerOffset * (i * 2 + 1);m_postMat.SetVector("_offsets", new Vector4(offset * 0.5f, offset, 0, 0));Graphics.Blit(tempEx, temp2, m_postMat, 1);offset = samplerOffset * (i * 2 + 2);m_postMat.SetVector("_offsets", new Vector4(offset * 0.5f, offset, 0, 0));Graphics.Blit(temp2, tempEx, m_postMat, 1);RenderTexture.ReleaseTemporary(temp2);}m_postMat.SetTexture("blurLeft", temp1);m_postMat.SetTexture("blurRight", tempEx);Graphics.Blit(null, mergeBlurRT, m_postMat, 2);m_postMat.SetTexture("_BlurTex", mergeBlurRT);m_postMat.SetVector("_LightColor", lightColor);m_postMat.SetFloat("_LightPower", lightPower);m_postMat.SetFloat("_LightRadiusOut", lightRadiusOut);m_postMat.SetFloat("_LightRadiusFadeOut", lightRadiusOutFade);m_postMat.SetFloat("_LightRadiusIn", lightRadiusIn);m_postMat.SetFloat("_LightRadiusFadeIn", lightRadiusInFade);SetFogParameter(targetCamera, m_postMat);Graphics.Blit(source, destination, m_postMat, 3);RenderTexture.ReleaseTemporary(temp1);RenderTexture.ReleaseTemporary(tempEx);RenderTexture.ReleaseTemporary(mergeBlurRT);}else{RenderTexture temp1 = RenderTexture.GetTemporary(rtWidth, rtHeight, 0, source.format);Vector3 viewPortLightPos = lightTransform == null ? new Vector3(.5f, .5f, 0) : targetCamera.WorldToViewportPoint(lightTransform.position);m_postMat.SetVector("_ColorThreshold", colorThreshold);m_postMat.SetVector("_LightPos", new Vector4(viewPortLightPos.x, viewPortLightPos.y, viewPortLightPos.z, 0));m_postMat.SetTexture("_MaskTexture", maskTexture);m_postMat.SetTexture("_ShapeMask", shapeTexture);Graphics.Blit(source, temp1, m_postMat, 0);m_postMat.SetVector("_LightPos", new Vector4(viewPortLightPos.x, viewPortLightPos.y, viewPortLightPos.z, 0));float samplerOffset = samplerScale / source.width;for (int i = 0;i < blurIteration;i++){RenderTexture temp2 = RenderTexture.GetTemporary(rtWidth, rtHeight, 0, source.format);float offset = samplerOffset * (i * 2 + 1);m_postMat.SetVector("_offsets", new Vector4(offset, offset, 0, 0));Graphics.Blit(temp1, temp2, m_postMat, 1);offset = samplerOffset * (i * 2 + 2);m_postMat.SetVector("_offsets", new Vector4(offset, offset, 0, 0));Graphics.Blit(temp2, temp1, m_postMat, 1);RenderTexture.ReleaseTemporary(temp2);}m_postMat.SetTexture("_BlurTex", temp1);m_postMat.SetVector("_LightColor", lightColor);m_postMat.SetFloat("_LightPower", lightPower);m_postMat.SetFloat("_LightRadiusOut", lightRadiusOut);m_postMat.SetFloat("_LightRadiusFadeOut", lightRadiusOutFade);m_postMat.SetFloat("_LightRadiusIn", lightRadiusIn);m_postMat.SetFloat("_LightRadiusFadeIn", lightRadiusInFade);SetFogParameter(targetCamera, m_postMat);Graphics.Blit(source, destination, m_postMat, 3);RenderTexture.ReleaseTemporary(temp1);}}else{Graphics.Blit(source, destination);}}private void SetFogParameter(Camera targetCam, Material material){Matrix4x4 frustumCorners = Matrix4x4.identity;float vFov = targetCam.fieldOfView;float near = targetCam.nearClipPlane;float aspect = targetCam.aspect;float halfHeight = near * Mathf.Tan(vFov * 0.5f * Mathf.Deg2Rad);Vector3 toRight = targetCam.transform.right * halfHeight * aspect;Vector3 toTop = targetCam.transform.up * halfHeight;var forward = targetCam.transform.forward;Vector3 topLeft = forward * near + toTop - toRight;float scale = topLeft.magnitude / near;topLeft.Normalize();topLeft *= scale;Vector3 topRight = forward * near + toRight + toTop;topRight.Normalize();topRight *= scale;Vector3 bottomLeft = forward * near - toTop - toRight;bottomLeft.Normalize();bottomLeft *= scale;Vector3 bottomRight = forward * near + toRight - toTop;bottomRight.Normalize();bottomRight *= scale;frustumCorners.SetRow(0, bottomLeft);frustumCorners.SetRow(1, bottomRight);frustumCorners.SetRow(2, topRight);frustumCorners.SetRow(3, topLeft);material.SetMatrix("_FrustumCornersRay", frustumCorners);}}}